function varargout = dm_publisher(varargin)
%dm_publisher M-file for dm_publisher.fig
%      dm_publisher, by itself, creates a new dm_publisher or raises the existing
%      singleton*.
%
%      H = dm_publisher returns the handle to a new dm_publisher or the handle to
%      the existing singleton*.
%
%      dm_publisher('Property','Value',...) creates a new dm_publisher using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to dm_publisher_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      dm_publisher('CALLBACK') and dm_publisher('CALLBACK',hObject,...) call the
%      local function named CALLBACK in dm_publisher.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help dm_publisher

% Last Modified by GUIDE v2.5 10-Mar-2011 17:15:56

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @dm_publisher_OpeningFcn, ...
                   'gui_OutputFcn',  @dm_publisher_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before dm_publisher is made visible.
function dm_publisher_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)

% Choose default command line output for dm_publisher
handles.output = hObject;
handles.pwdStr =''


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes dm_publisher wait for user response (see UIRESUME)
% uiwait(handles.camFigure);


% --- Outputs from this function are returned to the command line.
function varargout = dm_publisher_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function PathToMdl_Callback(hObject, eventdata, handles)
% hObject    handle to PathToMdl (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of PathToMdl as text
%        str2double(get(hObject,'String')) returns contents of PathToMdl as a double


% --- Executes during object creation, after setting all properties.
function PathToMdl_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PathToMdl (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
handles.PathToMdl = hObject;
guidata(hObject, handles);





% --- Executes on button press in browse.
function browse_Callback(hObject, eventdata, handles)
% hObject    handle to browse (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[filename, pathname] =  uigetfile({'*.mdl'},'Select Model File to Publish');
set(handles.PathToMdl, 'String', strcat(pathname,filename));





% --- Executes on button press in publish.
function publish_Callback(hObject, eventdata, handles)
% hObject    handle to publish (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
echo off
javalib = strcat(mfilename('fullpath'), 'bin');
files = dir(javalib);
nfiles = size(files);
pubDir = strcat(mfilename('fullpath'), 'PublishData');
mkdir(pubDir);
path2mdl = get(handles.PathToMdl, 'String');
echo on

sys = load_system(path2mdl);
if isobject(sys) == 0
    
   
    sysName = get_param(sys,'name');
    pubDir = strcat(pubDir, '/',sysName);
    mkdir(pubDir);
    
    for x = 1:nfiles
        filename = files(x).name
        if strcmp(filename,'.') == 0 && strcmp(filename,'..') == 0
            javaaddpath(strcat(javalib,'/', filename));
        end
    end

    oldOrient =  orient(sys)
    orient(sys,'landscape')
   % set(sys,'PaperPositionMode','auto')
    % set(sys, 'PaperType' , 'B0')
    sysName = get_param(sys,'name')
    set(sys, 'PaperOrientation' , 'portrait')
    diagPicDir = strcat(pubDir,'/', sysName ,'.jpg');
    print (sys, '-djpeg', '-zbuffer','-r200', diagPicDir)
  % saveas(sys, diagPicDir)
    handles.pwdStr
    pub = javaObject('com.ibm.rational.konitz.publish.Publisher', pubDir, get(handles.camuri, 'String'),get(handles.project, 'String'),get(handles.user, 'String'),handles.pwdStr);
    pub.createSystem(sysName, get_param(sys,'Description'));
    blocks = get_param (sys,'Blocks')
    numOfBlocks = size(blocks)
    for x = 1:numOfBlocks
              
        blockName = get_param (strcat(sysName,'/',blocks{x}),'name');
        blockPosition = get_param (strcat(sysName,'/',blocks{x}),'Position');
        blockType = get_param (strcat(sysName,'/',blocks{x}),'BlockType');
        blockDesc = get_param (strcat(sysName,'/',blocks{x}),'BlockDescription');
        
        dblArray = javaArray ('java.lang.Double', 4);

        dblArray(1) = java.lang.Double(blockPosition(1));
        dblArray(2) = java.lang.Double(blockPosition(2));
        dblArray(3) = java.lang.Double(blockPosition(3));
        dblArray(4) = java.lang.Double(blockPosition(4));
        pub.addBlock(blockName, blockType, blockDesc, dblArray);

        if strcmp(blockType, 'Constant') == 1
            pub.addProperty('Constant value', get_param (strcat(sysName,'/',blocks{x}),'Value'));
        elseif strcmp(blockType, 'Gain') == 1
            pub.addProperty('Gain',get_param (strcat(sysName,'/',blocks{x}),'Gain'));
            pub.addProperty('Multiplication',get_param (strcat(sysName,'/',blocks{x}),'Multiplication'));
        elseif strcmp(blockType, 'Inport') == 1 || strcmp(blockType, 'Outport') == 1
            pub.addProperty('Prot Number' , get_param (strcat(sysName,'/',blocks{x}),'Port'));
        end
    end
    pub.index();
   pub.publish();
    close_system(path2mdl, 0)
end

 
%clear java
%echo off
%javalib = strcat(mfilename('fullpath'), 'bin');
%files = dir(javalib);
%for x = 1:size(files);
 %   if strcmp(files(x).name,'.') == 0 && strcmp(files(x).name,'..') == 0 
  %      javarmpath(strcat(javalib,'/', files(x).name));
   % end    
%   echo on
    




function camuri_Callback(hObject, eventdata, handles)
% hObject    handle to camuri (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of camuri as text
%        str2double(get(hObject,'String')) returns contents of camuri as a double


% --- Executes during object creation, after setting all properties.
function camuri_CreateFcn(hObject, eventdata, handles)
% hObject    handle to camuri (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function user_Callback(hObject, eventdata, handles)
% hObject    handle to user (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of user as text
%        str2double(get(hObject,'String')) returns contents of user as a double


% --- Executes during object creation, after setting all properties.
function user_CreateFcn(hObject, eventdata, handles)
% hObject    handle to user (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function project_CreateFcn(hObject, eventdata, handles)
% hObject    handle to project (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function pwd_Callback(hObject, eventdata, handles)
% hObject    handle to pwd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of pwd as text
%        str2double(get(hObject,'String')) returns contents of pwd as a double

function pwd_kpfcn(hObject, eventdata, handles)
CC = get(handles.camFigure,'currentcharacter');  % The character user entered.
        num = int8(CC);

        if num == 13 
            return
        end

        E = get(hObject,'string');
        if num == 8  || num == 127         
        handles.pwdStr = '';
        set(hObject,'string','');
        
        elseif ~isempty(num)
            set(hObject,'string',[E,'*'])  ;  % Print out an asterisk in gui.
            handles.pwdStr = strcat(handles.pwdStr, CC);
           guidata(hObject, handles);
        end       
    
% --- Executes during object creation, after setting all properties.
function pwd_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pwd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





